using System;
using System.Collections.Generic;
using System.Text;
using Microsoft.SharePoint;
using Microsoft.SharePoint.WebPartPages;
using System.Xml.Serialization;
using System.ComponentModel;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Runtime.InteropServices;


namespace DevLeap.DateTimeWebPart
{
    [DefaultProperty("Gmt")]
    [ToolboxData("<{0}:DateTimeWP runat=server></{0}:DateTimeWP>")]
    [Guid("9D0389EC-1BD1-45b0-94ED-93CF4A79697C")]
    [XmlRoot(Namespace = "DateTimeWP")]
    public class DateTimeWP : WebPart
    {
        private const String defaultLabel = "Date e ora:";
        private const Int32 defaultGmt = 2;

        private Int32 _gmt = defaultGmt;
        private String _label = defaultLabel;

        [WebPartStorage(Storage.Personal)]
        // [Resources(Category = "Others", Description = "GMT", Name = "GMT")]
        [Category("Others")]
        [FriendlyName("GMT")]
        [Description("GMT")]
        [DefaultValue(defaultGmt)]
        [Browsable(true)]
        [XmlElement("gmt", IsNullable = false)]
        public Int32 Gmt
        {
            get { return _gmt; }
            set { _gmt = value; }
        }

        public virtual bool ShouldSerializeGmt()
        {
            return (this.Gmt != defaultGmt);
        }

        [WebPartStorage(Storage.Personal)]
        // [Resources(Category = "Others", Description = "Label", Name = "Label")]
        [Category("Others")]
        [FriendlyName("Label")]
        [Description("Label")]
        [DefaultValue(defaultLabel)]
        [Browsable(true)]
        [XmlElement("label", IsNullable = false)]
        public String Label
        {
            get { return _label; }
            set { _label = value; }
        }

        public virtual bool ShouldSerializeLabel()
        {
            return (this.Label != defaultLabel);
        }

        private Literal _literal;
        private Button _refresh;

        protected override void CreateChildControls()
        {
            _literal = new Literal();
            _literal.Text = String.Format("{0}&nbsp;<i>{1:dd-MM-yyyy HH:mm:ss}</i><br>&nbsp;<br>", this.Label, DateTime.Now.ToUniversalTime().AddHours(this.Gmt));
            this.Controls.Add(_literal);

            _refresh = new Button();
            _refresh.Text = "Refresh";
            _refresh.Click += new EventHandler(_refresh_Click);
            _refresh.CssClass = "UserButton";
            this.Controls.Add(_refresh);

            base.CreateChildControls();
        }

        void _refresh_Click(object sender, EventArgs e)
        {
            // Non faccio nulla, serve solo per fare il postback
        }

        protected override void RenderContents(HtmlTextWriter writer)
        {
            RenderChildren(writer);
        }
    }
}
