using System;
using System.Runtime.InteropServices;
using System.Web.UI;
using System.Web.UI.WebControls.WebParts;
using System.Xml.Serialization;

using Microsoft.SharePoint;
using Microsoft.SharePoint.WebControls;
using Microsoft.SharePoint.WebPartPages;
using DevLeap.MOSS2007.AsynWebParts.LongRunningServiceAgent;
using System.Web.UI.WebControls;

namespace DevLeap.MOSS2007.AsynWebPart
{
    [Guid("1aa5414b-b165-4833-a1c0-94b1525de4b5")]
    public class AsynWebPart : System.Web.UI.WebControls.WebParts.WebPart
    {
        public AsynWebPart()
        {
            this.ExportMode = WebPartExportMode.All;
        }


        private DataGrid gridOne;
        private DataGrid gridTwo;

        protected override void CreateChildControls()
        {
            base.CreateChildControls();

            this.gridOne = new DataGrid();
            this.gridTwo = new DataGrid();

            this.Controls.Add(this.gridOne);
            this.Controls.Add(this.gridTwo);
        }

        private DateTime startTime;
        private DateTime endTime;

        protected override void OnLoad(EventArgs e)
        {
            this.Page.PreRenderComplete += new EventHandler(Page_PreRenderComplete);

            startTime = DateTime.Now;

            base.OnLoad(e);

            this.EnsureChildControls();

            SPSite site = SPControl.GetContextSite(this.Context);

            Object[] stateOne = new Object[3];
            stateOne[0] = site.Url;
            stateOne[1] = site.RootWeb.Lists[0].Title;
            stateOne[2] = this.gridOne;

            this.Page.RegisterAsyncTask(new PageAsyncTask(
                this.BeginListItems,
                this.EndListItems, 
                this.TimeoutHandler, stateOne, true));

            Object[] stateTwo = new Object[3];
            stateTwo[0] = site.Url;
            stateTwo[1] = site.RootWeb.Lists[1].Title;
            stateTwo[2] = this.gridTwo;

            this.Page.RegisterAsyncTask(new PageAsyncTask(
                this.BeginListItems,
                this.EndListItems,
                this.TimeoutHandler, stateTwo, true));
        }

        private LongRunning ws;

        IAsyncResult BeginListItems(Object sender, EventArgs e, AsyncCallback cb, Object state)
        {
            if (ws == null)
                ws = new LongRunning();

            String siteUri = ((Object[])state)[0].ToString();
            String listName = ((Object[])state)[1].ToString();

            return (ws.BeginListItems(siteUri, listName, cb, state));
        }

        void EndListItems(IAsyncResult asyncResult)
        {
            DataGrid gridControl = ((Object[])asyncResult.AsyncState)[2] as DataGrid;

            String[] dataSource = ws.EndListItems(asyncResult);
            gridControl.DataSource = dataSource;
            gridControl.DataBind();
        }

        void TimeoutHandler(IAsyncResult asyncResult)
        {
            this.Controls.Add(new LiteralControl("Timeout expired!"));
        }

        void Page_PreRenderComplete(object sender, EventArgs e)
        {
            endTime = DateTime.Now;
            this.Controls.Add(new LiteralControl(String.Format("Start: {0} - End: {1}", startTime, endTime)));
            base.OnPreRender(e);
        }
    }
}
