﻿using System;
using System.Runtime.InteropServices;
using System.Web.UI;
using System.Web.UI.WebControls.WebParts;
using System.Xml.Serialization;

using Microsoft.SharePoint;
using Microsoft.SharePoint.WebControls;
using Microsoft.SharePoint.WebPartPages;
using System.Web.UI.WebControls;
using DevLeap.MOSS2007.AsynWebParts.LongRunningServiceAgent;

namespace SyncWebPart
{
    [Guid("25e969cf-481c-421e-bd9e-004e6ba52b90")]
    public class SyncWebPart : System.Web.UI.WebControls.WebParts.WebPart
    {
        public SyncWebPart()
        {
            this.ExportMode = WebPartExportMode.All;
        }

        private DataGrid gridOne;
        private DataGrid gridTwo;

        protected override void CreateChildControls()
        {
            base.CreateChildControls();

            this.gridOne = new DataGrid();
            this.gridTwo = new DataGrid();

            this.Controls.Add(this.gridOne);
            this.Controls.Add(this.gridTwo);
        }

        private DateTime startTime;
        private DateTime endTime;

        protected override void OnLoad(EventArgs e)
        {
            this.Page.PreRenderComplete += new EventHandler(Page_PreRenderComplete);

            startTime = DateTime.Now;

            base.OnLoad(e);

            LongRunning ws = new LongRunning();

            SPSite site = SPControl.GetContextSite(this.Context);

            String[] dataSourceOne = ws.ListItems(site.Url, site.RootWeb.Lists[0].Title);
            String[] dataSourceTwo = ws.ListItems(site.Url, site.RootWeb.Lists[1].Title);

            this.EnsureChildControls();

            this.gridOne.DataSource = dataSourceOne;
            this.gridOne.DataBind();

            this.gridTwo.DataSource = dataSourceTwo;
            this.gridTwo.DataBind();
        }

        //protected override void Render(HtmlTextWriter writer)
        //{

        //}

        void Page_PreRenderComplete(object sender, EventArgs e)
        {
            endTime = DateTime.Now;
            this.Controls.Add(new LiteralControl(String.Format("Start: {0} - End: {1}", startTime, endTime)));
            base.OnPreRender(e);
        }
    }
}
