using System;
using System.Collections.Generic;
using System.Text;
using Microsoft.SharePoint;
using Microsoft.SharePoint.Administration;
using System.Collections.ObjectModel;

namespace DevLeap.MOSS2007.CustomListFeature
{
    public class CustomListFeatureReceiver : SPFeatureReceiver
    {
        public override void FeatureActivated(SPFeatureReceiverProperties properties)
        {
            SPWebConfigModification modification =
                new SPWebConfigModification("mode", "configuration/system.web/customErrors");
            modification.Owner = "CustomListFeature";
            modification.Sequence = 0;
            modification.Type = SPWebConfigModification.SPWebConfigModificationType.EnsureAttribute;
            modification.Value = "Off";

            SPWeb web = (SPWeb)properties.Feature.Parent;
            SPWebApplication webApp = web.Site.WebApplication;
            webApp.WebConfigModifications.Add(modification);

            webApp.Farm.Services.GetValue<SPWebService>().ApplyWebConfigModifications();
            webApp.Update();
        }

        public override void FeatureDeactivating(SPFeatureReceiverProperties properties)
        {
            SPWeb web = (SPWeb)properties.Feature.Parent;
            SPWebApplication webApp = web.Site.WebApplication;
            Collection<SPWebConfigModification> modifications = webApp.WebConfigModifications;

            Int32 start = modifications.Count;

            for (Int32 c = start - 1; c >= 0; c--)
            {
                SPWebConfigModification modification = modifications[c];

                if (modification.Owner == "CustomListFeature")
                {
                    modification.Value = "On";
                }
            }

            webApp.Farm.Services.GetValue<SPWebService>().ApplyWebConfigModifications();
            webApp.Update();
        }

        public override void FeatureInstalled(SPFeatureReceiverProperties properties)
        {
        }

        public override void FeatureUninstalling(SPFeatureReceiverProperties properties)
        {
        }
    }
}
