using System;
using System.Runtime.InteropServices;
using System.Web.UI;
using System.Web.UI.WebControls.WebParts;
using System.Xml.Serialization;

using Microsoft.SharePoint;
using Microsoft.SharePoint.WebControls;
using Microsoft.SharePoint.WebPartPages;
using System.Web.UI.WebControls;

namespace DevLeap.MOSS2007.WebPartVerbs
{
    [Guid("8e61c4c1-c8db-4f34-bbb5-dd625751a35a")]
    public class WebPartVerbs : System.Web.UI.WebControls.WebParts.WebPart
    {
        public WebPartVerbs()
        {
            this.ExportMode = WebPartExportMode.All;
        }

        protected override void OnLoad(EventArgs e)
        {
            base.OnLoad(e);
            EnsureChildControls();
        }

        public override WebPartVerbCollection Verbs
        {
            get
            {
                WebPartVerb clientVerb =
                    new WebPartVerb("WebPartVerbs_clientVerb",
                    "javascript:window.alert('Client side Verb!');");
                clientVerb.Text = "Client side Verb";
                clientVerb.Description = "Press this menu to see a client side Verb";

                WebPartVerb serverVerb =
                    new WebPartVerb("WebPartVerbs_serverVerb",
                        serverVerb_Click);
                serverVerb.Text = "Server side Verb";
                serverVerb.Description = "Press this menu to see a server side Verb";
                serverVerb.ImageUrl = "/_layouts/images/REFRESH.GIF";

                WebPartVerb doubleVerb =
                    new WebPartVerb("WebPartVerbs_clientAndServerVerb",
                        doubleVerb_Click, 
                        "javascript:window.alert('Client side Verb of double side Verb')");
                doubleVerb.Text = "Double side Verb";
                doubleVerb.Description = "Press this menu to see a double side Verb";


                WebPartVerb[] newVerbs = new WebPartVerb[] { 
                    clientVerb, serverVerb, doubleVerb
                };

                return new WebPartVerbCollection(base.Verbs, newVerbs);
            }
        }

        public void serverVerb_Click(Object source, WebPartEventArgs e)
        {
            this.OutputControl.Text = "<div>Server side Verb pressed!</div>";
        }

        public void doubleVerb_Click(Object source, WebPartEventArgs e)
        {
            this.OutputControl.Text = "<div>Double side Verb pressed!</div>";
        }

        private Label OutputControl;

        protected override void CreateChildControls()
        {
            base.CreateChildControls();

            this.OutputControl = new Label();
            this.Controls.Add(this.OutputControl);
        }
    }
}
