using System;
using System.ComponentModel;
using System.ComponentModel.Design;
using System.Collections;
using System.Drawing;
using System.Workflow.ComponentModel.Compiler;
using System.Workflow.ComponentModel.Serialization;
using System.Workflow.ComponentModel;
using System.Workflow.ComponentModel.Design;
using System.Workflow.Runtime;
using System.Workflow.Activities;
using System.Workflow.Activities.Rules;
using System.Xml.Serialization;
using System.Xml;
using Microsoft.SharePoint;
using Microsoft.SharePoint.Workflow;
using Microsoft.SharePoint.WorkflowActions;
using Microsoft.Office.Workflow.Utility;

namespace DevLeap.MOSS2007.Workflows.DemoApproval
{
	public sealed partial class DemoApprovalWorkflow: SharePointSequentialWorkflowActivity
	{
		public DemoApprovalWorkflow()
		{
			InitializeComponent();
		}

        private String assignee = default(String);
        private String notes = default(String);

        public Guid workflowId = default(System.Guid);
        public Microsoft.SharePoint.Workflow.SPWorkflowActivationProperties workflowProperties = new Microsoft.SharePoint.Workflow.SPWorkflowActivationProperties();
        public Guid taskId = default(System.Guid);
        public SPWorkflowTaskProperties taskProperties = new Microsoft.SharePoint.Workflow.SPWorkflowTaskProperties();

        public SPWorkflowTaskProperties afterProperties = new Microsoft.SharePoint.Workflow.SPWorkflowTaskProperties();
        public SPWorkflowTaskProperties beforeProperties = new Microsoft.SharePoint.Workflow.SPWorkflowTaskProperties();

        private void onWorkflowActivated1_Invoked(object sender, ExternalDataEventArgs e)
        {
            // Prende l'id del WorkflowInstance
            workflowId = workflowProperties.WorkflowId;

            // Deserializza i dati di init
            XmlSerializer serializer = new XmlSerializer(typeof(InitData));
            XmlTextReader reader = new XmlTextReader(new System.IO.StringReader(workflowProperties.InitiationData));
            InitData initForm = (InitData)serializer.Deserialize(reader);

            // Tiene traccia di destinatario e note
            assignee = initForm.assignee;
            notes = initForm.notes;
        }

        private void createTask1_MethodInvoking(object sender, EventArgs e)
        {
            // Inizializza il task da creare
            taskId = Guid.NewGuid();
            taskProperties.Title = "Demo Task";
            taskProperties.AssignedTo = assignee;
            taskProperties.Description = notes;
            taskProperties.DueDate = DateTime.Now.AddDays(2);
            taskProperties.ExtendedProperties["notes"] = notes;
        }

        private bool isApproved;

        private void notApproved(object sender, ConditionalEventArgs e)
        {
            // Continua il while mentre non  approvato
            e.Result = !isApproved;
        }

        private void onTaskChanged1_Invoked(object sender, ExternalDataEventArgs e)
        {
            // Controlla se la modifica era l'approvazione
            Object taskApproved = afterProperties.ExtendedProperties["taskApproved"];
            if (taskApproved != null)
            {
                isApproved = Boolean.Parse(taskApproved.ToString());
            }
        }
    }
}
