using System;
using System.Collections.Generic;
using System.Text;
using System.Workflow.ComponentModel;
using Microsoft.SharePoint.Utilities;
using Microsoft.SharePoint;
using Microsoft.SharePoint.WebControls;
using System.Web;
using Microsoft.SharePoint.WorkflowActions;
using System.ComponentModel;
using Microsoft.SharePoint.Workflow;

namespace DevLeap.SD2007.Activities
{
    public class MoveItemActivity : Activity
    {
        public static DependencyProperty __ContextProperty = System.Workflow.ComponentModel.DependencyProperty.Register("__Context", typeof(WorkflowContext), typeof(MoveItemActivity));

        [Description("__Context")]
        [Category("Others")]
        [Browsable(true)]
        [DesignerSerializationVisibility(DesignerSerializationVisibility.Visible)]
        public WorkflowContext __Context
        {
            get
            {
                return ((WorkflowContext)(base.GetValue(MoveItemActivity.__ContextProperty)));
            }
            set
            {
                base.SetValue(MoveItemActivity.__ContextProperty, value);
            }
        }

        public static DependencyProperty ListIdProperty = System.Workflow.ComponentModel.DependencyProperty.Register("ListId", typeof(String), typeof(MoveItemActivity));

        [Description("ListId")]
        [Category("Others")]
        [Browsable(true)]
        [DesignerSerializationVisibility(DesignerSerializationVisibility.Visible)]
        public String ListId
        {
            get
            {
                return ((String)(base.GetValue(MoveItemActivity.ListIdProperty)));
            }
            set
            {
                base.SetValue(MoveItemActivity.ListIdProperty, value);
            }
        }

        public static DependencyProperty ListItemProperty = System.Workflow.ComponentModel.DependencyProperty.Register("ListItem", typeof(Int32), typeof(MoveItemActivity));

        [Description("ListItem")]
        [Category("Others")]
        [Browsable(true)]
        [DesignerSerializationVisibility(DesignerSerializationVisibility.Visible)]
        public Int32 ListItem
        {
            get
            {
                return ((Int32)(base.GetValue(MoveItemActivity.ListItemProperty)));
            }
            set
            {
                base.SetValue(MoveItemActivity.ListItemProperty, value);
            }
        }

        public static DependencyProperty ToListIdProperty = System.Workflow.ComponentModel.DependencyProperty.Register("ToListId", typeof(String), typeof(MoveItemActivity));

        [Description("ToListId")]
        [Category("Others")]
        [Browsable(true)]
        [DesignerSerializationVisibility(DesignerSerializationVisibility.Visible)]
        public String ToListId
        {
            get
            {
                return ((String)(base.GetValue(MoveItemActivity.ToListIdProperty)));
            }
            set
            {
                base.SetValue(MoveItemActivity.ToListIdProperty, value);
            }
        }

        public static DependencyProperty OverwriteProperty = System.Workflow.ComponentModel.DependencyProperty.Register("Overwrite", typeof(Boolean), typeof(MoveItemActivity));

        [Description("Overwrite")]
        [Category("Others")]
        [Browsable(true)]
        [DesignerSerializationVisibility(DesignerSerializationVisibility.Visible)]
        public Boolean Overwrite
        {
            get
            {
                return ((Boolean)(base.GetValue(MoveItemActivity.OverwriteProperty)));
            }
            set
            {
                base.SetValue(MoveItemActivity.OverwriteProperty, value);
            }
        }

        protected override ActivityExecutionStatus Execute(ActivityExecutionContext executionContext)
        {
            IListItemService listService = (IListItemService)executionContext.GetService<IListItemService>();

            try
            {
                Guid siteId = __Context.Site.ID;
                Guid webId = __Context.Web.ID;

                SPSecurity.RunWithElevatedPrivileges(delegate()
                {
                    SPSite site = new SPSite(siteId);
                    SPWeb web = site.OpenWeb(webId);

                    SPList sourceList = web.Lists[new Guid(this.ListId)];
                    SPListItem sourceItem = sourceList.GetItemById(this.ListItem);
                    SPList destinationList = web.Lists[new Guid(this.ToListId)];

                    if (sourceItem.File != null)
                    {
                        String destinationUri = destinationList.RootFolder.ServerRelativeUrl + "/" + sourceItem.File.Name;
                        sourceItem.File.MoveTo(destinationUri, this.Overwrite);
                    }
                });

            }
            catch (SPException)
            {
                // Qui mi gestisco l'errore
                return ActivityExecutionStatus.Faulting;
            }

            return ActivityExecutionStatus.Closed;
        }
    }
}
