using System;
using System.Collections.Generic;
using System.Text;
using Microsoft.SharePoint;
using System.Text.RegularExpressions;

namespace DevLeap.EHDemo
{
    public class AntiSpamming: SPItemEventReceiver
    {
        public override void ItemAdding(SPItemEventProperties properties)
        {
            validateItem(properties);
        }

        public override void ItemUpdating(SPItemEventProperties properties)
        {
            validateItem(properties);
        }

        private void validateItem(SPItemEventProperties properties)
        {
            Regex regex = new Regex(properties.ReceiverData, RegexOptions.IgnoreCase | RegexOptions.CultureInvariant);
            if ((properties.AfterUrl != null) && (regex.IsMatch(properties.AfterUrl)))
            {
                properties.ErrorMessage = "Spamming non consentito";
                properties.Cancel = true;
            }
        }
    }
}
