using System;
using System.Collections.Generic;
using System.Text;
using Microsoft.SharePoint;
using System.Reflection;

namespace DevLeap.EHReceiverConfigurator
{
    class Program
    {
        static void Main(string[] args)
        {
            using (SPSite site = new SPSite("http://moss2007dev/"))
            {
                using (SPWeb web = site.OpenWeb("SOGEI"))
                {
                    Guid listId = web.Lists.Add("EMails", "Email da conservare", SPListTemplateType.DocumentLibrary);
                    SPList list = web.Lists[listId];

                    SPEventReceiverDefinition receiver = list.EventReceivers.Add();

                    Assembly asm = Assembly.LoadFrom(@"C:\Sources\EHDemo\EHDemo\bin\Debug\DevLeap.EHDemo.dll");
                    receiver.Assembly = asm.FullName;
                    receiver.Class = asm.GetType("DevLeap.EHDemo.AntiSpamming").FullName;
                    receiver.Name = "Anti-Spamming";
                    receiver.Type = SPEventReceiverType.ItemAdding;
                    receiver.SequenceNumber = 100;
                    receiver.Data = "sex|drug|viagra|cialis|russo";
                    receiver.Update();

                    Console.WriteLine("Filtro configurato!");
                }
            }
        }
    }
}
